## visad.cluster
Class UserRendererJ3D

    java.lang.Object
      visad.DataRenderer
          visad.java3d.RendererJ3D
              visad.java3d.DefaultRendererJ3D
                  visad.cluster.UserRendererJ3D

All Implemented Interfaces:
  Cloneable

public class UserRendererJ3D
extends DefaultRendererJ3D

UserRendererJ3D is the VisAD DataRenderer for remote users connecting to a cluster via a proxy on the client.

Field Summary

Fields inherited from class visad.java3d.RendererJ3D
``

Fields inherited from class visad.DataRenderer
`enabled, pickCrawlToCursor`

Constructor Summary
`UserRendererJ3D()`
`UserRendererJ3D(RemoteProxyAgent a)`
`UserRendererJ3D(RemoteProxyAgent a, long to)`

Method Summary
`Object` `clone()`
`DataShadow` `computeRanges(Data data, ShadowType type, DataShadow shadow)` Compute ranges of values for each RealType in DisplayImpl.RealTypeVector.
`javax.media.j3d.Node` `convertSceneGraph(VisADSceneGraphObject scene)`
`javax.media.j3d.BranchGroup` `doTransform()` create a scene graph for Data in links[0]
`static void` `main(String[] args)`
`DataShadow` `prepareAction(boolean go, boolean initialize, DataShadow shadow)` check if re-transform is needed; if initialize is true then compute ranges for RealTypes and Animation sampling
`void` `setResolutions(int[] rs)`
`void` `setSpatialValues(float[][] spatial_values)` set spatial values for Data depiction; used to detect when direct manipulation mouse selects a point of a Data depiction

Methods inherited from class visad.java3d.DefaultRendererJ3D
`addSwitch, clearScene, getLink, setLinks`

Methods inherited from class visad.java3d.RendererJ3D
`clearBranch, doAction, flush, getBranch, makeShadowFunctionType, makeShadowRealTupleType, makeShadowRealType, makeShadowSetType, makeShadowTextType, makeShadowTupleType, setBranchEarly, toggle`

Methods inherited from class visad.DataRenderer

`addException, addPoint, checkAction, checkClose, checkDirect, clearAVControls, clearExceptions, drag_direct, earthToSpatial, earthToSpatial, findRayManifoldIntersection, get_all_feasible, get_any_changed, get_any_transform_control, getBadScale, getDisplay, getDisplayCoordinateSystem, getDisplayRenderer, getEarthDimension, getEarthUnits, getEnabled, getExceptionVector, getIsDirectManipulation, getLastMouseModifiers, getLatLonIndices, getLatLonRange, getLinks, getPickCrawlToCursor, getRanges, getRealVectorTypes, getWhyNotDirect, isLegalTextureMap, isTransformControl, realCheckDirect, release_direct, removeLink, set_all_feasible, setDisplay, setDisplayRenderer, setEarthSpatialData, setEarthSpatialDisplay, setIsDirectManipulation, setLastMouseModifiers, setLatLonIndices, setLinks, setPickCrawlToCursor, spatialToEarth, spatialToEarth, stop_direct, suppressExceptions`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UserRendererJ3D

    public UserRendererJ3D()

### UserRendererJ3D

    public UserRendererJ3D(RemoteProxyAgent a)

### UserRendererJ3D

    public UserRendererJ3D(RemoteProxyAgent a,
                           long to)

Method Detail

### setResolutions

    public void setResolutions(int[] rs)
                        throws RemoteException

  Throws:
    `RemoteException`

### prepareAction

    public DataShadow prepareAction(boolean go,
                                    boolean initialize,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Description copied from class: `DataRenderer`
  check if re-transform is needed; if initialize is true then compute ranges for RealTypes and Animation sampling

  Overrides:
    `prepareAction` in class `DataRenderer`
  Parameters:
    `go` - flag indicating that re-transform is required for at least one DataRenderer linked to DisplayImpl
    `initialize` - flag indicating that initialization (i.e., auto-scaling) is required
    `shadow` - DataShadow shared by prepareAction() method of all DataRenderers linked to DisplayImpl
  Returns:
    DataShadow containing ranges and animation sampling Set (return null if no need for initialization)
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### doTransform

    public javax.media.j3d.BranchGroup doTransform()
                                            throws VisADException,
                                                   RemoteException

  create a scene graph for Data in links[0]

  Overrides:
    `doTransform` in class `DefaultRendererJ3D`
  Throws:
    `VisADException`
    `RemoteException`

### setSpatialValues

    public void setSpatialValues(float[][] spatial_values)

  Description copied from class: `DataRenderer`
  set spatial values for Data depiction; used to detect when direct manipulation mouse selects a point of a Data depiction

  Overrides:
    `setSpatialValues` in class `DataRenderer`
  Parameters:
    `spatial_values` - float[3][number_of_points] of 3-D locations of depiction points

### convertSceneGraph

    public javax.media.j3d.Node convertSceneGraph(VisADSceneGraphObject scene)
                                           throws VisADException

  Throws:
    `VisADException`

### computeRanges

    public DataShadow computeRanges(Data data,
                                    ShadowType type,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Description copied from class: `DataRenderer`
  Compute ranges of values for each RealType in DisplayImpl.RealTypeVector.

  Overrides:
    `computeRanges` in class `DataRenderer`
  Parameters:
    `data` - Data object in which to compute ranges of RealType values
    `type` - ShadowType generated for MathType of data
    `shadow` - DataShadow instance whose contained double[][] array and animation sampling Set are modified according to RealType values in data, and used as return value
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### clone

    public Object clone()

  Overrides:
    `clone` in class `DefaultRendererJ3D`

### main

    public static void main(String[] args)
                     throws VisADException,
                            RemoteException

  Throws:
    `VisADException`
    `RemoteException`